#ifndef COMMON_STRING_ARRAY_H
#define COMMON_STRING_ARRAY_H

#include "common/array.h"
#include "common/maybe_unused.h"
#include "common/string.h"
#include <stdlib.h>

ARRAY(StringView, StringViewArray, stringview_array)

MAYBE_UNUSED static inline StringViewArray* stringview_array_new(void)
{
	StringViewArray* array = malloc(sizeof(StringViewArray));
	stringview_array_construct(array);
	return array;
}
MAYBE_UNUSED static inline void stringview_array_delete(StringViewArray* array)
{
	stringview_array_destroy(array);
	free(array);
}

ARRAY(HeapString, HeapStringArray, heapstring_array)

MAYBE_UNUSED static inline HeapStringArray* heapstring_array_new(void)
{
	HeapStringArray* array = malloc(sizeof(HeapStringArray));
	heapstring_array_construct(array);
	return array;
}
MAYBE_UNUSED static inline void heapstring_array_delete(HeapStringArray* array)
{
	heapstring_array_destroy(array);
	free(array);
}

#endif
